unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi, activex, CAPICOM_TLB, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtContrasena: TEdit;
    txtFicheroEncriptar: TEdit;
    Label2: TLabel;
    txtFicheroDestinoEncriptado: TEdit;
    Label3: TLabel;
    txtAlgoritmoEncriptacion: TComboBox;
    Label4: TLabel;
    LWEB: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    txtContrasenaDesencriptar: TEdit;
    txtFicheroDesencriptar: TEdit;
    txtFicheroDestinoDesencriptado: TEdit;
    btEncriptar: TBitBtn;
    btDesencriptar: TBitBtn;
    btSelFicEncriptar: TBitBtn;
    BitBtn1: TBitBtn;
    bSelFicDes: TBitBtn;
    BitBtn3: TBitBtn;
    dlAbrir: TOpenDialog;
    txtTamanoDatosEncriptar: TComboBox;
    Label9: TLabel;
    btSalir: TBitBtn;
    StatusBar1: TStatusBar;
    procedure LWEBClick(Sender: TObject);
    procedure btEncriptarClick(Sender: TObject);
    procedure btDesencriptarClick(Sender: TObject);
    procedure btSelFicEncriptarClick(Sender: TObject);
    procedure txtFicheroEncriptarChange(Sender: TObject);
    procedure bSelFicDesClick(Sender: TObject);
    procedure txtFicheroDesencriptarChange(Sender: TObject);
    procedure btSalirClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  algoritmo: CAPICOM_ENCRYPTION_ALGORITHM = CAPICOM_ENCRYPTION_ALGORITHM_RC2;
  tamanoDatosAlgoritmo: CAPICOM_ENCRYPTION_KEY_LENGTH =
    CAPICOM_ENCRYPTION_KEY_LENGTH_MAXIMUM;



procedure encriptar (contrasena : string; ficheroEncriptar : string;
    ficheroDestino : string);
var
  EncryptedData: IEncryptedData;
  Buffer: WideString;
  FileStm: TFileStream;
begin
  //rear objeto EncryptedData
  EncryptedData := CoEncryptedData.Create;
  // Indicamos el algoritmo de encriptacin a usar
  EncryptedData.Algorithm.Name := algoritmo;
  //Establecemos el tamao del algoritmo de encriptacin
  EncryptedData.Algorithm.KeyLength := tamanoDatosAlgoritmo;
  //Establecemos la contrasea
  EncryptedData.SetSecret(contrasena, CAPICOM_SECRET_PASSWORD);

  FileStm := TFileStream.Create(ficheroEncriptar,
      fmOpenRead or fmShareDenyWrite);
  try     
    Pointer(Buffer):= SysAllocStringByteLen (nil, FileStm.Size);
    FileStm.ReadBuffer(Pointer(Buffer)^, FileStm.Size);
    EncryptedData.Content:= Buffer;
  finally
    FileStm.Free;
  end;
  //Encriptar fichero
  Buffer:= EncryptedData.Encrypt(CAPICOM_ENCODE_BINARY);
  //Guardar fichero encritado en fichero destino
  FileStm := TFileStream.Create(ficheroDestino, fmCreate or fmShareDenyWrite);
  try
    FileStm.WriteBuffer(Pointer(Buffer)^, SysStringByteLen(PWideChar(Buffer)));
  finally
    FileStm.Free;
  end;
  MessageDlg('Fichero encriptado.', mtInformation, [mbok], 0);
end;

procedure desencriptar (contrasena : string; ficheroDesencriptar : string;
    ficheroDestino : string);
var
  EncryptedData: IEncryptedData;
  Buffer: WideString;
  FileStm: TFileStream;
begin
  //Crear objeto EncryptedData
  EncryptedData := CoEncryptedData.Create;
  //Establecemos la contrasea
  EncryptedData.SetSecret(contrasena, CAPICOM_SECRET_PASSWORD);
  //Cargamos el fichero a desencriptar
  FileStm := TFileStream.Create(ficheroDesencriptar,
      fmOpenRead or fmShareDenyWrite);
  try
    pointer(Buffer):= SysAllocStringByteLen(nil, FileStm.Size);
    FileStm.ReadBuffer(Pointer(Buffer)^, FileStm.Size);
  finally
    FileStm.Free;
  end;
  //Desencriptamos el fichero en memoria
  EncryptedData.Decrypt(Buffer);
  Buffer := EncryptedData.Content;
  //Guardamos el fichero desencriptado en memoria en el fichero destino
  FileStm:= TFileStream.Create(ficheroDestino, fmCreate or fmShareDenyWrite);
  try
    FileStm.WriteBuffer(Pointer(Buffer)^, SysStringByteLen(PWideChar(Buffer)));
  finally
    FileStm.Free;
  end;
  MessageDlg('Fichero desencriptado.', mtInformation, [mbok], 0);
end;

procedure TForm1.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TForm1.btEncriptarClick(Sender: TObject);
begin
  if txtAlgoritmoEncriptacion.Text = 'RC2' then
    algoritmo := CAPICOM_ENCRYPTION_ALGORITHM_RC2
  else
    if txtAlgoritmoEncriptacion.Text = 'RC4' then
      algoritmo := CAPICOM_ENCRYPTION_ALGORITHM_RC4
    else
      if txtAlgoritmoEncriptacion.Text = 'DES' then
        algoritmo := CAPICOM_ENCRYPTION_ALGORITHM_DES
      else
        if txtAlgoritmoEncriptacion.Text = '3DES' then
            algoritmo := CAPICOM_ENCRYPTION_ALGORITHM_3DES
        else
          if txtAlgoritmoEncriptacion.Text = 'AES' then
            algoritmo := CAPICOM_ENCRYPTION_ALGORITHM_AES;

  if txtTamanoDatosEncriptar.Text = '256 bits' then
    tamanoDatosAlgoritmo := CAPICOM_ENCRYPTION_KEY_LENGTH_256_BITS
  else
    if txtTamanoDatosEncriptar.Text = '192 bits' then
      tamanoDatosAlgoritmo := CAPICOM_ENCRYPTION_KEY_LENGTH_192_BITS
    else
      if txtTamanoDatosEncriptar.Text = '128 bits' then
        tamanoDatosAlgoritmo := CAPICOM_ENCRYPTION_KEY_LENGTH_128_BITS
      else
        if txtTamanoDatosEncriptar.Text = '56 bits' then
          tamanoDatosAlgoritmo := CAPICOM_ENCRYPTION_KEY_LENGTH_56_BITS
        else
          if txtTamanoDatosEncriptar.Text = '40 bits' then
            tamanoDatosAlgoritmo := CAPICOM_ENCRYPTION_KEY_LENGTH_40_BITS;

  encriptar(txtContrasena.Text, txtFicheroEncriptar.Text,
      txtFicheroDestinoEncriptado.Text);
end;

procedure TForm1.btDesencriptarClick(Sender: TObject);
begin
  desencriptar (txtContrasenaDesencriptar.Text, txtFicheroDesencriptar.Text,
      txtFicheroDestinoDesencriptado.Text);
end;

procedure TForm1.btSelFicEncriptarClick(Sender: TObject);
begin
  dlAbrir.Title := 'Seleccione el fichero a encriptar';
  if dlAbrir.Execute then
    txtFicheroEncriptar.Text := dlAbrir.FileName;
end;

procedure TForm1.txtFicheroEncriptarChange(Sender: TObject);
begin
  if FileExists (txtFicheroEncriptar.Text) then
  begin
    txtFicheroDestinoEncriptado.Text :=
        IncludeTrailingPathDelimiter (ExtractFilePath(txtFicheroEncriptar.Text))
        + 'ENCRIPTADO--' + ExtractFileName (txtFicheroEncriptar.Text);
  end;
end;

procedure TForm1.bSelFicDesClick(Sender: TObject);
begin
  dlAbrir.Title := 'Seleccione el fichero a desencriptar';
  if dlAbrir.Execute then
    txtFicheroDesencriptar.Text := dlAbrir.FileName;
end;

procedure TForm1.txtFicheroDesencriptarChange(Sender: TObject);
begin
  if FileExists (txtFicheroDesencriptar.Text) then
  begin
    txtFicheroDestinoDesencriptado.Text :=
        IncludeTrailingPathDelimiter (ExtractFilePath(txtFicheroDesencriptar.Text))
        + 'DESENCRIPTADO--' + ExtractFileName (txtFicheroDesencriptar.Text);
  end;
end;

procedure TForm1.btSalirClick(Sender: TObject);
begin
  Close;
end;

end.
 